class NotValidPathException implements Exception {
  const NotValidPathException(this.whyNot, this.accessFromType, this.wantsType);

  // TODO(mpfaff): refactor `whyNot` to `reason`
  final String whyNot;
  final Type accessFromType;
  final Type wantsType;

  @override
  String toString() => 'To get a $wantsType from a $accessFromType, $whyNot';
}

class OperationNotAllowedException {
  const OperationNotAllowedException(this.message);

  final String message;
}
